# Python 3.6+
# 1. ADIM için örnek kodlar

import base64
import hashlib
import hmac
import json
import requests

# API Entegrasyon Bilgilier - Mağaza paneline giriş yaparak BİLGİ sayfasından alabilirsiniz.
merchant_id = 'XXXXXX'
merchant_key = b'YYYYYYYYYYYYYY'
merchant_salt = 'ZZZZZZZZZZZZZZ'

# Eğer bu kodu sunucuda değil local makinanızda çalıştırıyorsanız buraya dış ip adresinizi(https://www.whatismyip.com/) yazmalısınız.
user_ip = ''

# Sipariş numarası: her işlemde benzersiz olmalıdır! Bu bilgi bildirim sayfanıza yapılacak bildirimde gönderilir.
merchant_oid = ''

# Müşterinizin sitenizde kayıtlı eposta adresi
email = 'musteri@saglayici.com'

# Tahsil edilecek tutar. 9.99 için 9.99 * 100 = 999 gönderilmelidir.
payment_amount = ''

payment_type = 'eft'

# Hataları ekrana basmak için kullanılır.
debug_on = '1'

# İşlem zaman aşımı süresi - dakika cinsinden
timeout_limit = '30'

# Mağaza canlı modda iken test işlem yapmak için 1 olarak gönderilebilir
test_mode = '0'

# Bu kısımda herhangi bir değişiklik yapmanıza gerek yoktur
hash_str = merchant_id + user_ip + merchant_oid + email + payment_amount + payment_type + test_mode + merchant_salt
paytr_token = base64.b64encode(hmac.new(merchant_key, hash_str.encode(), hashlib.sha256).digest())

params = {
    'merchant_id': merchant_id,
    'user_ip': user_ip,
    'merchant_oid': merchant_oid,
    'email': email,
    'payment_amount': payment_amount,
    'payment_type': payment_type,
    'paytr_token': paytr_token,
    'debug_on': debug_on,
    'timeout_limit': timeout_limit,
    'test_mode': test_mode
}

result = requests.post('https://www.paytr.com/odeme/api/get-token', params)
res = json.loads(result.text)

if res['status'] == 'success':
    print(res['token'])
else:
    print('PAYTR EFT IFRAME failed. reason:' + res['reason'])